(function () { "use strict";
var $estr = function() { return js.Boot.__string_rec(this,''); };
function $extend(from, fields) {
	function inherit() {}; inherit.prototype = from; var proto = new inherit();
	for (var name in fields) proto[name] = fields[name];
	return proto;
}
var HxOverrides = function() { }
HxOverrides.__name__ = true;
HxOverrides.cca = function(s,index) {
	var x = s.charCodeAt(index);
	if(x != x) return undefined;
	return x;
}
HxOverrides.iter = function(a) {
	return { cur : 0, arr : a, hasNext : function() {
		return this.cur < this.arr.length;
	}, next : function() {
		return this.arr[this.cur++];
	}};
}
var List = function() {
	this.length = 0;
};
List.__name__ = true;
List.prototype = {
	iterator: function() {
		return { h : this.h, hasNext : function() {
			return this.h != null;
		}, next : function() {
			if(this.h == null) return null;
			var x = this.h[0];
			this.h = this.h[1];
			return x;
		}};
	}
	,remove: function(v) {
		var prev = null;
		var l = this.h;
		while(l != null) {
			if(l[0] == v) {
				if(prev == null) this.h = l[1]; else prev[1] = l[1];
				if(this.q == l) this.q = prev;
				this.length--;
				return true;
			}
			prev = l;
			l = l[1];
		}
		return false;
	}
	,isEmpty: function() {
		return this.h == null;
	}
	,pop: function() {
		if(this.h == null) return null;
		var x = this.h[0];
		this.h = this.h[1];
		if(this.h == null) this.q = null;
		this.length--;
		return x;
	}
	,add: function(item) {
		var x = [item];
		if(this.h == null) this.h = x; else this.q[1] = x;
		this.q = x;
		this.length++;
	}
	,__class__: List
}
var IMap = function() { }
IMap.__name__ = true;
var Reflect = function() { }
Reflect.__name__ = true;
Reflect.field = function(o,field) {
	var v = null;
	try {
		v = o[field];
	} catch( e ) {
	}
	return v;
}
Reflect.fields = function(o) {
	var a = [];
	if(o != null) {
		var hasOwnProperty = Object.prototype.hasOwnProperty;
		for( var f in o ) {
		if(f != "__id__" && hasOwnProperty.call(o,f)) a.push(f);
		}
	}
	return a;
}
Reflect.isFunction = function(f) {
	return typeof(f) == "function" && !(f.__name__ || f.__ename__);
}
var Std = function() { }
Std.__name__ = true;
Std.string = function(s) {
	return js.Boot.__string_rec(s,"");
}
var StringBuf = function() {
	this.b = "";
};
StringBuf.__name__ = true;
StringBuf.prototype = {
	__class__: StringBuf
}
var ValueType = { __ename__ : true, __constructs__ : ["TNull","TInt","TFloat","TBool","TObject","TFunction","TClass","TEnum","TUnknown"] }
ValueType.TNull = ["TNull",0];
ValueType.TNull.toString = $estr;
ValueType.TNull.__enum__ = ValueType;
ValueType.TInt = ["TInt",1];
ValueType.TInt.toString = $estr;
ValueType.TInt.__enum__ = ValueType;
ValueType.TFloat = ["TFloat",2];
ValueType.TFloat.toString = $estr;
ValueType.TFloat.__enum__ = ValueType;
ValueType.TBool = ["TBool",3];
ValueType.TBool.toString = $estr;
ValueType.TBool.__enum__ = ValueType;
ValueType.TObject = ["TObject",4];
ValueType.TObject.toString = $estr;
ValueType.TObject.__enum__ = ValueType;
ValueType.TFunction = ["TFunction",5];
ValueType.TFunction.toString = $estr;
ValueType.TFunction.__enum__ = ValueType;
ValueType.TClass = function(c) { var $x = ["TClass",6,c]; $x.__enum__ = ValueType; $x.toString = $estr; return $x; }
ValueType.TEnum = function(e) { var $x = ["TEnum",7,e]; $x.__enum__ = ValueType; $x.toString = $estr; return $x; }
ValueType.TUnknown = ["TUnknown",8];
ValueType.TUnknown.toString = $estr;
ValueType.TUnknown.__enum__ = ValueType;
var Type = function() { }
Type.__name__ = true;
Type["typeof"] = function(v) {
	var _g = typeof(v);
	switch(_g) {
	case "boolean":
		return ValueType.TBool;
	case "string":
		return ValueType.TClass(String);
	case "number":
		if(Math.ceil(v) == v % 2147483648.0) return ValueType.TInt;
		return ValueType.TFloat;
	case "object":
		if(v == null) return ValueType.TNull;
		var e = v.__enum__;
		if(e != null) return ValueType.TEnum(e);
		var c = v.__class__;
		if(c != null) return ValueType.TClass(c);
		return ValueType.TObject;
	case "function":
		if(v.__name__ || v.__ename__) return ValueType.TObject;
		return ValueType.TFunction;
	case "undefined":
		return ValueType.TNull;
	default:
		return ValueType.TUnknown;
	}
}
Type.enumIndex = function(e) {
	return e[1];
}
var common = {}
common.Config = function() { }
common.Config.__name__ = true;
common.Config.getTypeName = function(code) {
	return (function($this) {
		var $r;
		switch(code) {
		case 2:
			$r = "bot";
			break;
		case 1:
			$r = "human";
			break;
		case 0:
			$r = (function($this) {
				var $r;
				return null;
				return $r;
			}($this));
			break;
		default:
			$r = "unknown";
		}
		return $r;
	}(this));
}
common.Config.getPlatformName = function(code) {
	return (function($this) {
		var $r;
		switch(code) {
		case 3:
			$r = "android";
			break;
		case 1:
			$r = "linux";
			break;
		case 4:
			$r = "html5";
			break;
		case 2:
			$r = "flash";
			break;
		case 6:
			$r = "win";
			break;
		case 7:
			$r = "ios";
			break;
		case 5:
			$r = "node.js";
			break;
		case 0:
			$r = (function($this) {
				var $r;
				return null;
				return $r;
			}($this));
			break;
		default:
			$r = "unknown";
		}
		return $r;
	}(this));
}
common.Config.getPlatform = function() {
	return 4;
}
common.MsgQueue = function() {
	this.msgs = new List();
};
common.MsgQueue.__name__ = true;
common.MsgQueue.prototype = {
	addBytes: function(bytes) {
		if(bytes == null) return;
		if(this.bytesBuff == null) this.bytesBuff = bytes; else {
			var buffer = new haxe.io.BytesBuffer();
			buffer.add(this.bytesBuff);
			buffer.add(bytes);
			this.bytesBuff = buffer.getBytes();
		}
		if(this.bytesBuff == null || this.bytesBuff.length < 2) return;
		var available = this.bytesBuff.length;
		var bi = new haxe.io.BytesInput(this.bytesBuff);
		bi.set_bigEndian(false);
		while(available >= 2) {
			var packetSize = bi.readUInt16();
			available -= 2;
			if(packetSize <= available) {
				available -= packetSize;
				var msgBytes = bi.read(packetSize);
				var msg = new samples.ProtocolMessage();
				msg.mergeFrom(msgBytes);
				this.msgs.add(msg);
			} else {
				available += 2;
				break;
			}
		}
		if(available == 0) this.bytesBuff = null; else if(available > 0) {
			if(this.bytesBuff.length != available) {
				var pos = this.bytesBuff.length - available;
				this.bytesBuff = this.bytesBuff.sub(pos,available);
			}
		} else throw "Wrong available: " + available;
	}
	,addMsg: function(msg) {
		this.msgs.add(msg);
	}
	,popMsg: function() {
		return this.msgs.pop();
	}
	,hasMsg: function() {
		return !this.msgs.isEmpty();
	}
	,__class__: common.MsgQueue
}
var haxe = {}
haxe.Int64 = function(high,low) {
	this.high = high | 0;
	this.low = low | 0;
};
haxe.Int64.__name__ = true;
haxe.Int64.getLow = function(x) {
	return x.low;
}
haxe.Int64.getHigh = function(x) {
	return x.high;
}
haxe.Int64.sub = function(a,b) {
	var high = a.high - b.high;
	var low = a.low - b.low;
	if(haxe.Int64.uicompare(a.low,b.low) < 0) high--;
	return new haxe.Int64(high,low);
}
haxe.Int64.divMod = function(modulus,divisor) {
	var quotient = new haxe.Int64(0,0);
	var mask = new haxe.Int64(0,1);
	divisor = new haxe.Int64(divisor.high,divisor.low);
	while(divisor.high >= 0) {
		var cmp = haxe.Int64.ucompare(divisor,modulus);
		divisor.high = divisor.high << 1 | divisor.low >>> 31;
		divisor.low <<= 1;
		mask.high = mask.high << 1 | mask.low >>> 31;
		mask.low <<= 1;
		if(cmp >= 0) break;
	}
	while((mask.low | mask.high) != 0) {
		if(haxe.Int64.ucompare(modulus,divisor) >= 0) {
			quotient.high |= mask.high;
			quotient.low |= mask.low;
			modulus = haxe.Int64.sub(modulus,divisor);
		}
		mask.low = mask.low >>> 1 | mask.high << 31;
		mask.high >>>= 1;
		divisor.low = divisor.low >>> 1 | divisor.high << 31;
		divisor.high >>>= 1;
	}
	return { quotient : quotient, modulus : modulus};
}
haxe.Int64.neg = function(a) {
	var high = ~a.high;
	var low = -a.low;
	if(low == 0) high++;
	return new haxe.Int64(high,low);
}
haxe.Int64.uicompare = function(a,b) {
	return a < 0?b < 0?~b - ~a:1:b < 0?-1:a - b;
}
haxe.Int64.ucompare = function(a,b) {
	var v = haxe.Int64.uicompare(a.high,b.high);
	return v != 0?v:haxe.Int64.uicompare(a.low,b.low);
}
haxe.Int64.prototype = {
	toString: function() {
		if((this.high | this.low) == 0) return "0";
		var str = "";
		var neg = false;
		var i = this;
		if(i.high < 0) {
			neg = true;
			i = haxe.Int64.neg(i);
		}
		var ten = new haxe.Int64(0,10);
		while(!((i.high | i.low) == 0)) {
			var r = haxe.Int64.divMod(i,ten);
			str = r.modulus.low + str;
			i = r.quotient;
		}
		if(neg) str = "-" + str;
		return str;
	}
	,__class__: haxe.Int64
}
haxe.Json = function() {
};
haxe.Json.__name__ = true;
haxe.Json.stringify = function(value,replacer) {
	return new haxe.Json().toString(value,replacer);
}
haxe.Json.prototype = {
	quote: function(s) {
		this.buf.b += "\"";
		var i = 0;
		while(true) {
			var c = s.charCodeAt(i++);
			if(c != c) break;
			switch(c) {
			case 34:
				this.buf.b += "\\\"";
				break;
			case 92:
				this.buf.b += "\\\\";
				break;
			case 10:
				this.buf.b += "\\n";
				break;
			case 13:
				this.buf.b += "\\r";
				break;
			case 9:
				this.buf.b += "\\t";
				break;
			case 8:
				this.buf.b += "\\b";
				break;
			case 12:
				this.buf.b += "\\f";
				break;
			default:
				this.buf.b += String.fromCharCode(c);
			}
		}
		this.buf.b += "\"";
	}
	,toStringRec: function(k,v) {
		if(this.replacer != null) v = this.replacer(k,v);
		var _g = Type["typeof"](v);
		var $e = (_g);
		switch( $e[1] ) {
		case 8:
			this.buf.b += "\"???\"";
			break;
		case 4:
			this.objString(v);
			break;
		case 1:
			var v1 = v;
			this.buf.b += Std.string(v1);
			break;
		case 2:
			this.buf.b += Std.string(Math.isFinite(v)?v:"null");
			break;
		case 5:
			this.buf.b += "\"<fun>\"";
			break;
		case 6:
			var _g_eTClass_0 = $e[2];
			if(_g_eTClass_0 == String) this.quote(v); else if(_g_eTClass_0 == Array) {
				var v1 = v;
				this.buf.b += "[";
				var len = v1.length;
				if(len > 0) {
					this.toStringRec(0,v1[0]);
					var i = 1;
					while(i < len) {
						this.buf.b += ",";
						this.toStringRec(i,v1[i++]);
					}
				}
				this.buf.b += "]";
			} else if(_g_eTClass_0 == haxe.ds.StringMap) {
				var v1 = v;
				var o = { };
				var $it0 = v1.keys();
				while( $it0.hasNext() ) {
					var k1 = $it0.next();
					o[k1] = v1.get(k1);
				}
				this.objString(o);
			} else this.objString(v);
			break;
		case 7:
			var i = Type.enumIndex(v);
			var v1 = i;
			this.buf.b += Std.string(v1);
			break;
		case 3:
			var v1 = v;
			this.buf.b += Std.string(v1);
			break;
		case 0:
			this.buf.b += "null";
			break;
		}
	}
	,objString: function(v) {
		this.fieldsString(v,Reflect.fields(v));
	}
	,fieldsString: function(v,fields) {
		var first = true;
		this.buf.b += "{";
		var _g = 0;
		while(_g < fields.length) {
			var f = fields[_g];
			++_g;
			var value = Reflect.field(v,f);
			if(Reflect.isFunction(value)) continue;
			if(first) first = false; else this.buf.b += ",";
			this.quote(f);
			this.buf.b += ":";
			this.toStringRec(f,value);
		}
		this.buf.b += "}";
	}
	,toString: function(v,replacer) {
		this.buf = new StringBuf();
		this.replacer = replacer;
		this.toStringRec("",v);
		return this.buf.b;
	}
	,__class__: haxe.Json
}
haxe.ds = {}
haxe.ds.IntMap = function() {
	this.h = { };
};
haxe.ds.IntMap.__name__ = true;
haxe.ds.IntMap.__interfaces__ = [IMap];
haxe.ds.IntMap.prototype = {
	keys: function() {
		var a = [];
		for( var key in this.h ) {
		if(this.h.hasOwnProperty(key)) a.push(key | 0);
		}
		return HxOverrides.iter(a);
	}
	,get: function(key) {
		return this.h[key];
	}
	,set: function(key,value) {
		this.h[key] = value;
	}
	,__class__: haxe.ds.IntMap
}
haxe.ds.StringMap = function() { }
haxe.ds.StringMap.__name__ = true;
haxe.ds.StringMap.__interfaces__ = [IMap];
haxe.ds.StringMap.prototype = {
	keys: function() {
		var a = [];
		for( var key in this.h ) {
		if(this.h.hasOwnProperty(key)) a.push(key.substr(1));
		}
		return HxOverrides.iter(a);
	}
	,get: function(key) {
		return this.h["$" + key];
	}
	,__class__: haxe.ds.StringMap
}
haxe.io = {}
haxe.io.Bytes = function(length,b) {
	this.length = length;
	this.b = b;
};
haxe.io.Bytes.__name__ = true;
haxe.io.Bytes.alloc = function(length) {
	var a = new Array();
	var _g = 0;
	while(_g < length) {
		var i = _g++;
		a.push(0);
	}
	return new haxe.io.Bytes(length,a);
}
haxe.io.Bytes.ofString = function(s) {
	var a = new Array();
	var _g1 = 0, _g = s.length;
	while(_g1 < _g) {
		var i = _g1++;
		var c = s.charCodeAt(i);
		if(c <= 127) a.push(c); else if(c <= 2047) {
			a.push(192 | c >> 6);
			a.push(128 | c & 63);
		} else if(c <= 65535) {
			a.push(224 | c >> 12);
			a.push(128 | c >> 6 & 63);
			a.push(128 | c & 63);
		} else {
			a.push(240 | c >> 18);
			a.push(128 | c >> 12 & 63);
			a.push(128 | c >> 6 & 63);
			a.push(128 | c & 63);
		}
	}
	return new haxe.io.Bytes(a.length,a);
}
haxe.io.Bytes.ofData = function(b) {
	return new haxe.io.Bytes(b.length,b);
}
haxe.io.Bytes.prototype = {
	toHex: function() {
		var s = new StringBuf();
		var chars = [];
		var str = "0123456789abcdef";
		var _g1 = 0, _g = str.length;
		while(_g1 < _g) {
			var i = _g1++;
			chars.push(HxOverrides.cca(str,i));
		}
		var _g1 = 0, _g = this.length;
		while(_g1 < _g) {
			var i = _g1++;
			var c = this.b[i];
			s.b += String.fromCharCode(chars[c >> 4]);
			s.b += String.fromCharCode(chars[c & 15]);
		}
		return s.b;
	}
	,toString: function() {
		return this.readString(0,this.length);
	}
	,readString: function(pos,len) {
		if(pos < 0 || len < 0 || pos + len > this.length) throw haxe.io.Error.OutsideBounds;
		var s = "";
		var b = this.b;
		var fcc = String.fromCharCode;
		var i = pos;
		var max = pos + len;
		while(i < max) {
			var c = b[i++];
			if(c < 128) {
				if(c == 0) break;
				s += fcc(c);
			} else if(c < 224) s += fcc((c & 63) << 6 | b[i++] & 127); else if(c < 240) {
				var c2 = b[i++];
				s += fcc((c & 31) << 12 | (c2 & 127) << 6 | b[i++] & 127);
			} else {
				var c2 = b[i++];
				var c3 = b[i++];
				s += fcc((c & 15) << 18 | (c2 & 127) << 12 | c3 << 6 & 127 | b[i++] & 127);
			}
		}
		return s;
	}
	,sub: function(pos,len) {
		if(pos < 0 || len < 0 || pos + len > this.length) throw haxe.io.Error.OutsideBounds;
		return new haxe.io.Bytes(len,this.b.slice(pos,pos + len));
	}
	,__class__: haxe.io.Bytes
}
haxe.io.BytesBuffer = function() {
	this.b = new Array();
};
haxe.io.BytesBuffer.__name__ = true;
haxe.io.BytesBuffer.prototype = {
	getBytes: function() {
		var bytes = new haxe.io.Bytes(this.b.length,this.b);
		this.b = null;
		return bytes;
	}
	,addBytes: function(src,pos,len) {
		if(pos < 0 || len < 0 || pos + len > src.length) throw haxe.io.Error.OutsideBounds;
		var b1 = this.b;
		var b2 = src.b;
		var _g1 = pos, _g = pos + len;
		while(_g1 < _g) {
			var i = _g1++;
			this.b.push(b2[i]);
		}
	}
	,add: function(src) {
		var b1 = this.b;
		var b2 = src.b;
		var _g1 = 0, _g = src.length;
		while(_g1 < _g) {
			var i = _g1++;
			this.b.push(b2[i]);
		}
	}
	,__class__: haxe.io.BytesBuffer
}
haxe.io.Input = function() { }
haxe.io.Input.__name__ = true;
haxe.io.Input.prototype = {
	getDoubleSig: function(bytes) {
		return ((bytes[1] & 15) << 16 | bytes[2] << 8 | bytes[3]) * 4294967296. + (bytes[4] >> 7) * 2147483648 + ((bytes[4] & 127) << 24 | bytes[5] << 16 | bytes[6] << 8 | bytes[7]);
	}
	,readString: function(len) {
		var b = haxe.io.Bytes.alloc(len);
		this.readFullBytes(b,0,len);
		return b.toString();
	}
	,readInt32: function() {
		var ch1 = this.readByte();
		var ch2 = this.readByte();
		var ch3 = this.readByte();
		var ch4 = this.readByte();
		return this.bigEndian?ch4 | ch3 << 8 | ch2 << 16 | ch1 << 24:ch1 | ch2 << 8 | ch3 << 16 | ch4 << 24;
	}
	,readUInt16: function() {
		var ch1 = this.readByte();
		var ch2 = this.readByte();
		return this.bigEndian?ch2 | ch1 << 8:ch1 | ch2 << 8;
	}
	,readDouble: function() {
		var bytes = [];
		bytes.push(this.readByte());
		bytes.push(this.readByte());
		bytes.push(this.readByte());
		bytes.push(this.readByte());
		bytes.push(this.readByte());
		bytes.push(this.readByte());
		bytes.push(this.readByte());
		bytes.push(this.readByte());
		if(this.bigEndian) bytes.reverse();
		var sign = 1 - (bytes[0] >> 7 << 1);
		var exp = (bytes[0] << 4 & 2047 | bytes[1] >> 4) - 1023;
		var sig = this.getDoubleSig(bytes);
		if(sig == 0 && exp == -1023) return 0.0;
		return sign * (1.0 + Math.pow(2,-52) * sig) * Math.pow(2,exp);
	}
	,readFloat: function() {
		var bytes = [];
		bytes.push(this.readByte());
		bytes.push(this.readByte());
		bytes.push(this.readByte());
		bytes.push(this.readByte());
		if(this.bigEndian) bytes.reverse();
		var sign = 1 - (bytes[0] >> 7 << 1);
		var exp = (bytes[0] << 1 & 255 | bytes[1] >> 7) - 127;
		var sig = (bytes[1] & 127) << 16 | bytes[2] << 8 | bytes[3];
		if(sig == 0 && exp == -127) return 0.0;
		return sign * (1 + Math.pow(2,-23) * sig) * Math.pow(2,exp);
	}
	,read: function(nbytes) {
		var s = haxe.io.Bytes.alloc(nbytes);
		var p = 0;
		while(nbytes > 0) {
			var k = this.readBytes(s,p,nbytes);
			if(k == 0) throw haxe.io.Error.Blocked;
			p += k;
			nbytes -= k;
		}
		return s;
	}
	,readFullBytes: function(s,pos,len) {
		while(len > 0) {
			var k = this.readBytes(s,pos,len);
			pos += k;
			len -= k;
		}
	}
	,set_bigEndian: function(b) {
		this.bigEndian = b;
		return b;
	}
	,readBytes: function(s,pos,len) {
		var k = len;
		var b = s.b;
		if(pos < 0 || len < 0 || pos + len > s.length) throw haxe.io.Error.OutsideBounds;
		while(k > 0) {
			b[pos] = this.readByte();
			pos++;
			k--;
		}
		return len;
	}
	,readByte: function() {
		return (function($this) {
			var $r;
			throw "Not implemented";
			return $r;
		}(this));
	}
	,__class__: haxe.io.Input
}
haxe.io.BytesInput = function(b,pos,len) {
	if(pos == null) pos = 0;
	if(len == null) len = b.length - pos;
	if(pos < 0 || len < 0 || pos + len > b.length) throw haxe.io.Error.OutsideBounds;
	this.b = b.b;
	this.pos = pos;
	this.len = len;
};
haxe.io.BytesInput.__name__ = true;
haxe.io.BytesInput.__super__ = haxe.io.Input;
haxe.io.BytesInput.prototype = $extend(haxe.io.Input.prototype,{
	readBytes: function(buf,pos,len) {
		if(pos < 0 || len < 0 || pos + len > buf.length) throw haxe.io.Error.OutsideBounds;
		if(this.len == 0 && len > 0) throw new haxe.io.Eof();
		if(this.len < len) len = this.len;
		var b1 = this.b;
		var b2 = buf.b;
		var _g = 0;
		while(_g < len) {
			var i = _g++;
			b2[pos + i] = b1[this.pos + i];
		}
		this.pos += len;
		this.len -= len;
		return len;
	}
	,readByte: function() {
		if(this.len == 0) throw new haxe.io.Eof();
		this.len--;
		return this.b[this.pos++];
	}
	,__class__: haxe.io.BytesInput
});
haxe.io.Output = function() { }
haxe.io.Output.__name__ = true;
haxe.io.Output.prototype = {
	writeInt32: function(x) {
		if(this.bigEndian) {
			this.writeByte(x >>> 24);
			this.writeByte(x >> 16 & 255);
			this.writeByte(x >> 8 & 255);
			this.writeByte(x & 255);
		} else {
			this.writeByte(x & 255);
			this.writeByte(x >> 8 & 255);
			this.writeByte(x >> 16 & 255);
			this.writeByte(x >>> 24);
		}
	}
	,writeUInt16: function(x) {
		if(x < 0 || x >= 65536) throw haxe.io.Error.Overflow;
		if(this.bigEndian) {
			this.writeByte(x >> 8);
			this.writeByte(x & 255);
		} else {
			this.writeByte(x & 255);
			this.writeByte(x >> 8);
		}
	}
	,writeDouble: function(x) {
		if(x == 0.0) {
			this.writeByte(0);
			this.writeByte(0);
			this.writeByte(0);
			this.writeByte(0);
			this.writeByte(0);
			this.writeByte(0);
			this.writeByte(0);
			this.writeByte(0);
			return;
		}
		var exp = Math.floor(Math.log(Math.abs(x)) / haxe.io.Output.LN2);
		var sig = Math.floor(Math.abs(x) / Math.pow(2,exp) * Math.pow(2,52));
		var sig_h = sig & 34359738367;
		var sig_l = Math.floor(sig / Math.pow(2,32));
		var b1 = exp + 1023 >> 4 | (exp > 0?x < 0?128:64:x < 0?128:0), b2 = exp + 1023 << 4 & 255 | sig_l >> 16 & 15, b3 = sig_l >> 8 & 255, b4 = sig_l & 255, b5 = sig_h >> 24 & 255, b6 = sig_h >> 16 & 255, b7 = sig_h >> 8 & 255, b8 = sig_h & 255;
		if(this.bigEndian) {
			this.writeByte(b8);
			this.writeByte(b7);
			this.writeByte(b6);
			this.writeByte(b5);
			this.writeByte(b4);
			this.writeByte(b3);
			this.writeByte(b2);
			this.writeByte(b1);
		} else {
			this.writeByte(b1);
			this.writeByte(b2);
			this.writeByte(b3);
			this.writeByte(b4);
			this.writeByte(b5);
			this.writeByte(b6);
			this.writeByte(b7);
			this.writeByte(b8);
		}
	}
	,writeFloat: function(x) {
		if(x == 0.0) {
			this.writeByte(0);
			this.writeByte(0);
			this.writeByte(0);
			this.writeByte(0);
			return;
		}
		var exp = Math.floor(Math.log(Math.abs(x)) / haxe.io.Output.LN2);
		var sig = Math.floor(Math.abs(x) / Math.pow(2,exp) * 8388608) & 8388607;
		var b1 = exp + 127 >> 1 | (exp > 0?x < 0?128:64:x < 0?128:0), b2 = exp + 127 << 7 & 255 | sig >> 16 & 127, b3 = sig >> 8 & 255, b4 = sig & 255;
		if(this.bigEndian) {
			this.writeByte(b4);
			this.writeByte(b3);
			this.writeByte(b2);
			this.writeByte(b1);
		} else {
			this.writeByte(b1);
			this.writeByte(b2);
			this.writeByte(b3);
			this.writeByte(b4);
		}
	}
	,writeFullBytes: function(s,pos,len) {
		while(len > 0) {
			var k = this.writeBytes(s,pos,len);
			pos += k;
			len -= k;
		}
	}
	,write: function(s) {
		var l = s.length;
		var p = 0;
		while(l > 0) {
			var k = this.writeBytes(s,p,l);
			if(k == 0) throw haxe.io.Error.Blocked;
			p += k;
			l -= k;
		}
	}
	,set_bigEndian: function(b) {
		this.bigEndian = b;
		return b;
	}
	,writeBytes: function(s,pos,len) {
		var k = len;
		var b = s.b;
		if(pos < 0 || len < 0 || pos + len > s.length) throw haxe.io.Error.OutsideBounds;
		while(k > 0) {
			this.writeByte(b[pos]);
			pos++;
			k--;
		}
		return len;
	}
	,writeByte: function(c) {
		throw "Not implemented";
	}
	,__class__: haxe.io.Output
}
haxe.io.BytesOutput = function() {
	this.b = new haxe.io.BytesBuffer();
};
haxe.io.BytesOutput.__name__ = true;
haxe.io.BytesOutput.__super__ = haxe.io.Output;
haxe.io.BytesOutput.prototype = $extend(haxe.io.Output.prototype,{
	getBytes: function() {
		return this.b.getBytes();
	}
	,writeBytes: function(buf,pos,len) {
		this.b.addBytes(buf,pos,len);
		return len;
	}
	,writeByte: function(c) {
		this.b.b.push(c);
	}
	,__class__: haxe.io.BytesOutput
});
haxe.io.Eof = function() {
};
haxe.io.Eof.__name__ = true;
haxe.io.Eof.prototype = {
	toString: function() {
		return "Eof";
	}
	,__class__: haxe.io.Eof
}
haxe.io.Error = { __ename__ : true, __constructs__ : ["Blocked","Overflow","OutsideBounds","Custom"] }
haxe.io.Error.Blocked = ["Blocked",0];
haxe.io.Error.Blocked.toString = $estr;
haxe.io.Error.Blocked.__enum__ = haxe.io.Error;
haxe.io.Error.Overflow = ["Overflow",1];
haxe.io.Error.Overflow.toString = $estr;
haxe.io.Error.Overflow.__enum__ = haxe.io.Error;
haxe.io.Error.OutsideBounds = ["OutsideBounds",2];
haxe.io.Error.OutsideBounds.toString = $estr;
haxe.io.Error.OutsideBounds.__enum__ = haxe.io.Error;
haxe.io.Error.Custom = function(e) { var $x = ["Custom",3,e]; $x.__enum__ = haxe.io.Error; $x.toString = $estr; return $x; }
var js = {}
js.Boot = function() { }
js.Boot.__name__ = true;
js.Boot.__string_rec = function(o,s) {
	if(o == null) return "null";
	if(s.length >= 5) return "<...>";
	var t = typeof(o);
	if(t == "function" && (o.__name__ || o.__ename__)) t = "object";
	switch(t) {
	case "object":
		if(o instanceof Array) {
			if(o.__enum__) {
				if(o.length == 2) return o[0];
				var str = o[0] + "(";
				s += "\t";
				var _g1 = 2, _g = o.length;
				while(_g1 < _g) {
					var i = _g1++;
					if(i != 2) str += "," + js.Boot.__string_rec(o[i],s); else str += js.Boot.__string_rec(o[i],s);
				}
				return str + ")";
			}
			var l = o.length;
			var i;
			var str = "[";
			s += "\t";
			var _g = 0;
			while(_g < l) {
				var i1 = _g++;
				str += (i1 > 0?",":"") + js.Boot.__string_rec(o[i1],s);
			}
			str += "]";
			return str;
		}
		var tostr;
		try {
			tostr = o.toString;
		} catch( e ) {
			return "???";
		}
		if(tostr != null && tostr != Object.toString) {
			var s2 = o.toString();
			if(s2 != "[object Object]") return s2;
		}
		var k = null;
		var str = "{\n";
		s += "\t";
		var hasp = o.hasOwnProperty != null;
		for( var k in o ) { ;
		if(hasp && !o.hasOwnProperty(k)) {
			continue;
		}
		if(k == "prototype" || k == "__class__" || k == "__super__" || k == "__interfaces__" || k == "__properties__") {
			continue;
		}
		if(str.length != 2) str += ", \n";
		str += s + k + " : " + js.Boot.__string_rec(o[k],s);
		}
		s = s.substring(1);
		str += "\n" + s + "}";
		return str;
	case "function":
		return "<function>";
	case "string":
		return o;
	default:
		return String(o);
	}
}
js.Boot.__interfLoop = function(cc,cl) {
	if(cc == null) return false;
	if(cc == cl) return true;
	var intf = cc.__interfaces__;
	if(intf != null) {
		var _g1 = 0, _g = intf.length;
		while(_g1 < _g) {
			var i = _g1++;
			var i1 = intf[i];
			if(i1 == cl || js.Boot.__interfLoop(i1,cl)) return true;
		}
	}
	return js.Boot.__interfLoop(cc.__super__,cl);
}
js.Boot.__instanceof = function(o,cl) {
	try {
		if(o instanceof cl) {
			if(cl == Array) return o.__enum__ == null;
			return true;
		}
		if(js.Boot.__interfLoop(o.__class__,cl)) return true;
	} catch( e ) {
		if(cl == null) return false;
	}
	switch(cl) {
	case Int:
		return Math.ceil(o%2147483648.0) === o;
	case Float:
		return typeof(o) == "number";
	case Bool:
		return o === true || o === false;
	case String:
		return typeof(o) == "string";
	case Dynamic:
		return true;
	default:
		if(o == null) return false;
		if(cl == Class && o.__name__ != null) return true; else null;
		if(cl == Enum && o.__ename__ != null) return true; else null;
		return o.__enum__ == cl;
	}
}
js.Boot.__cast = function(o,t) {
	if(js.Boot.__instanceof(o,t)) return o; else throw "Cannot cast " + Std.string(o) + " to " + Std.string(t);
}
js.NodeC = function() { }
js.NodeC.__name__ = true;
js.Node = function() { }
js.Node.__name__ = true;
js.Node.newSocket = function(options) {
	return new js.Node.net.Socket(options);
}
var protohx = {}
protohx.CommonError = function(msg) {
};
protohx.CommonError.__name__ = true;
protohx.CommonError.prototype = {
	__class__: protohx.CommonError
}
protohx.Message = function() {
};
protohx.Message.__name__ = true;
protohx.Message.stringToByteArray = function(s) {
	return haxe.io.Bytes.ofString(s);
}
protohx.Message.prototype = {
	forEachFields: function(fn) {
	}
	,writeExtensionOrUnknownFields: function(output) {
		if(this.otherFields != null) {
			var $it0 = this.otherFields.keys();
			while( $it0.hasNext() ) {
				var tag = $it0.next();
				this.writeUnknown(output,tag);
			}
		}
	}
	,defaultUInt64: function() {
		return protohx.Protohx.newUInt64(0,0);
	}
	,defaultInt64: function() {
		return protohx.Protohx.newInt64(0,0);
	}
	,defaultBytes: function() {
		return null;
	}
	,setByTag: function(tag,value) {
		if(this.otherFields == null) this.otherFields = new haxe.ds.IntMap();
		this.otherFields.set(tag,value);
	}
	,getByTag: function(tag) {
		return this.otherFields != null?this.otherFields.get(tag):null;
	}
	,readUnknown: function(input,tag) {
		var value;
		var _g = tag & 7;
		switch(_g) {
		case 0:
			value = protohx.ReadUtils.read__TYPE_UINT64(input);
			break;
		case 1:
			value = protohx.ReadUtils.read__TYPE_FIXED64(input);
			break;
		case 2:
			value = protohx.ReadUtils.read__TYPE_BYTES(input);
			break;
		case 5:
			value = protohx.ReadUtils.read__TYPE_FIXED32(input);
			break;
		default:
			throw new protohx.CommonError("Invalid wire type: " + (tag & 7));
		}
		var currentValue = this.getByTag(tag);
		if(currentValue == null) this.setByTag(tag,value); else if(js.Boot.__instanceof(currentValue,Array)) currentValue.push(value); else this.setByTag(tag,[currentValue,value]);
	}
	,writeUnknown: function(output,tag) {
		if(tag == 0) throw new protohx.CommonError("Attemp to write an undefined string filed: " + tag);
		protohx.WriteUtils.writeUnknownPair(output,tag,this.getByTag(tag));
	}
	,writeSingleUnknown: function(output,tag,value) {
		protohx.WriteUtils.write__TYPE_UINT32(output,tag);
		var _g = tag & 7;
		switch(_g) {
		case 0:
			protohx.WriteUtils.write__TYPE_UINT64(output,value);
			break;
		case 1:
			protohx.WriteUtils.write__TYPE_FIXED64(output,value);
			break;
		case 2:
			protohx.WriteUtils.write__TYPE_BYTES(output,value);
			break;
		case 5:
			protohx.WriteUtils.write__TYPE_FIXED32(output,value);
			break;
		default:
			throw new protohx.CommonError("Invalid wire type: " + (tag & 7));
		}
	}
	,writeToBuffer: function(output) {
		this.writeExtensionOrUnknownFields(output);
	}
	,hasBytes: function(input,bytesAfterSlice) {
		return input.bytesAvailable > bytesAfterSlice;
	}
	,readFromSlice: function(input,bytesAfterSlice) {
		while(input.bytesAvailable > bytesAfterSlice) {
			var tag = protohx.ReadUtils.read__TYPE_UINT32(input);
			this.readUnknown(input,tag);
		}
	}
	,writeDelimitedTo: function(output) {
		var buffer = new protohx.WritingBuffer();
		protohx.WriteUtils.write__TYPE_MESSAGE(buffer,this);
		buffer.toNormal(output);
	}
	,writeTo: function(output) {
		var buffer = new protohx.WritingBuffer();
		this.writeToBuffer(buffer);
		buffer.toNormal(output);
	}
	,mergeDelimitedFrom: function(input) {
		protohx.ReadUtils.read__TYPE_MESSAGE(new protohx.ReadingBuffer(input),this);
	}
	,mergeFrom: function(input) {
		this.readFromSlice(new protohx.ReadingBuffer(input),0);
	}
	,__class__: protohx.Message
}
protohx.MessageUtils = function() { }
protohx.MessageUtils.__name__ = true;
protohx.MessageUtils.toObject = function(value,keepNulls) {
	if(keepNulls == null) keepNulls = false;
	if(value == null || js.Boot.__instanceof(value,String) || js.Boot.__instanceof(value,Float) || js.Boot.__instanceof(value,Int) || js.Boot.__instanceof(value,Bool)) return value; else if(js.Boot.__instanceof(value,haxe.io.Bytes)) return (js.Boot.__cast(value , haxe.io.Bytes)).toHex(); else if(js.Boot.__instanceof(value,haxe.Int64)) return (js.Boot.__cast(value , haxe.Int64)).toString(); else if(js.Boot.__instanceof(value,protohx.Message)) {
		var m = { };
		var msg = js.Boot.__cast(value , protohx.Message);
		msg.forEachFields(function(f,v) {
			m[f] = protohx.MessageUtils.toObject(v,keepNulls);
		});
		return m;
	} else if(js.Boot.__instanceof(value,Array)) {
		var a = [];
		var _g = 0, _g1 = js.Boot.__cast(value , Array);
		while(_g < _g1.length) {
			var sv = _g1[_g];
			++_g;
			a.push(protohx.MessageUtils.toObject(sv,keepNulls));
		}
		return a;
	} else return Std.string(value);
	return null;
}
protohx.MessageUtils.toJson = function(msg,keepNulls) {
	if(keepNulls == null) keepNulls = false;
	var o = protohx.MessageUtils.toObject(msg,keepNulls);
	return haxe.Json.stringify(o);
}
protohx.Protohx = function() { }
protohx.Protohx.__name__ = true;
protohx.Protohx.getLow = function(i) {
	return js.Boot.__cast(haxe.Int64.getLow(i) , Int);
}
protohx.Protohx.getHigh = function(i) {
	return js.Boot.__cast(haxe.Int64.getHigh(i) , Int);
}
protohx.Protohx.newInt64 = function(h,l) {
	return new haxe.Int64(h,l);
}
protohx.Protohx.newUInt64 = function(h,l) {
	return new haxe.Int64(h,l);
}
protohx.Protohx.setOutputEndian = function(out) {
	out.set_bigEndian(false);
}
protohx.Protohx.setInputEndian = function(out) {
	out.set_bigEndian(false);
}
protohx.ReadUtils = function() { }
protohx.ReadUtils.__name__ = true;
protohx.ReadUtils.skip = function(input,wireType) {
	switch(wireType) {
	case 0:
		while(input.readUnsignedByte() >= 128) {
		}
		break;
	case 1:
		input.readInt32();
		input.readInt32();
		break;
	case 2:
		var i = protohx.ReadUtils.read__TYPE_UINT32(input);
		while(i != 0) {
			input.readUnsignedByte();
			i--;
		}
		break;
	case 5:
		input.readInt32();
		break;
	default:
		throw new protohx.CommonError("Invalid wire type: " + wireType);
	}
}
protohx.ReadUtils.read__TYPE_DOUBLE = function(input) {
	return input.readDouble();
}
protohx.ReadUtils.read__TYPE_FLOAT = function(input) {
	return input.readFloat();
}
protohx.ReadUtils.read__TYPE_INT64 = function(input) {
	var low = 0;
	var high = 0;
	var b = 0;
	var i = 0;
	while(true) {
		b = input.readUnsignedByte();
		if(i == 28) break; else if(b >= 128) low |= (b & 127) << i; else {
			low |= b << i;
			return protohx.Protohx.newInt64(high,low);
		}
		i += 7;
	}
	if(b >= 128) {
		b &= 127;
		low |= b << i;
		high = b >>> 4;
	} else {
		low |= b << i;
		high = b >>> 4;
		return protohx.Protohx.newInt64(high,low);
	}
	i = 3;
	while(true) {
		b = input.readUnsignedByte();
		if(i < 32) {
			if(b >= 128) high |= (b & 127) << i; else {
				high |= b << i;
				break;
			}
		}
		i += 7;
	}
	return protohx.Protohx.newInt64(high,low);
}
protohx.ReadUtils.read__TYPE_UINT64 = function(input) {
	var tmp = protohx.ReadUtils.read__TYPE_INT64(input);
	return protohx.Protohx.newUInt64(js.Boot.__cast(haxe.Int64.getHigh(tmp) , Int),js.Boot.__cast(haxe.Int64.getLow(tmp) , Int));
}
protohx.ReadUtils.read__TYPE_INT32 = function(input) {
	return protohx.ReadUtils.read__TYPE_UINT32(input);
}
protohx.ReadUtils.read__TYPE_FIXED64 = function(input) {
	var low = input.readInt32();
	var high = input.readInt32();
	return protohx.Protohx.newUInt64(high,low);
}
protohx.ReadUtils.read__TYPE_FIXED32 = function(input) {
	return input.readInt32();
}
protohx.ReadUtils.read__TYPE_BOOL = function(input) {
	return protohx.ReadUtils.read__TYPE_UINT32(input) != 0;
}
protohx.ReadUtils.read__TYPE_STRING = function(input) {
	var length = protohx.ReadUtils.read__TYPE_UINT32(input);
	return input.readUTFBytes(length);
}
protohx.ReadUtils.read__TYPE_BYTES = function(input) {
	var result = null;
	var length = protohx.ReadUtils.read__TYPE_UINT32(input);
	if(length > 0) result = input.readBytes(length);
	return result;
}
protohx.ReadUtils.read__TYPE_UINT32 = function(input) {
	var result = 0;
	var i = 0;
	while(true) {
		var b = input.readUnsignedByte();
		if(i < 32) {
			if(b >= 128) result |= (b & 127) << i; else {
				result |= b << i;
				break;
			}
		} else {
			while(input.readUnsignedByte() >= 128) {
			}
			break;
		}
		i += 7;
	}
	return result;
}
protohx.ReadUtils.read__TYPE_ENUM = function(input) {
	return protohx.ReadUtils.read__TYPE_INT32(input);
}
protohx.ReadUtils.read__TYPE_SFIXED32 = function(input) {
	return input.readInt32();
}
protohx.ReadUtils.read__TYPE_SFIXED64 = function(input) {
	var low = input.readInt32();
	var high = input.readInt32();
	return protohx.Protohx.newInt64(high,low);
}
protohx.ReadUtils.read__TYPE_SINT32 = function(input) {
	return protohx.ZigZag.decode32(protohx.ReadUtils.read__TYPE_UINT32(input));
}
protohx.ReadUtils.read__TYPE_SINT64 = function(input) {
	var result = protohx.ReadUtils.read__TYPE_INT64(input);
	var low = js.Boot.__cast(haxe.Int64.getLow(result) , Int);
	var high = js.Boot.__cast(haxe.Int64.getHigh(result) , Int);
	var lowNew = protohx.ZigZag.decode64low(low,high);
	var highNew = protohx.ZigZag.decode64high(low,high);
	return protohx.Protohx.newInt64(highNew,lowNew);
}
protohx.ReadUtils.read__TYPE_MESSAGE = function(input,message) {
	var length = protohx.ReadUtils.read__TYPE_UINT32(input);
	if(input.bytesAvailable < length) throw new protohx.CommonError("Invalid message length: " + length);
	var bytesAfterSlice = input.bytesAvailable - length;
	message.readFromSlice(input,bytesAfterSlice);
	if(input.bytesAvailable != bytesAfterSlice) throw new protohx.CommonError("Invalid nested message");
	return message;
}
protohx.ReadUtils.readPackedRepeated = function(input,readFuntion,value) {
	var length = protohx.ReadUtils.read__TYPE_UINT32(input);
	if(input.bytesAvailable < length) throw new protohx.CommonError("Invalid message length: " + length);
	var bytesAfterSlice = input.bytesAvailable - length;
	while(input.bytesAvailable > bytesAfterSlice) value.push(readFuntion(input));
	if(input.bytesAvailable != bytesAfterSlice) throw new protohx.CommonError("Invalid packed repeated data");
}
protohx.ReadingBuffer = function(bytes) {
	this.length = bytes.length;
	this.bytesAvailable = this.length;
	this.buf = new haxe.io.BytesInput(bytes);
	protohx.Protohx.setInputEndian(this.buf);
};
protohx.ReadingBuffer.__name__ = true;
protohx.ReadingBuffer.prototype = {
	readFloat: function() {
		this.bytesAvailable -= 4;
		return this.buf.readFloat();
	}
	,readDouble: function() {
		this.bytesAvailable -= 8;
		return this.buf.readDouble();
	}
	,readUnsignedByte: function() {
		this.bytesAvailable -= 1;
		return this.buf.readByte();
	}
	,readInt32: function() {
		this.bytesAvailable -= 4;
		return this.buf.readInt32();
	}
	,readUTFBytes: function(len) {
		this.bytesAvailable -= len;
		return this.buf.readString(len);
	}
	,readBytes: function(len) {
		var b = haxe.io.Bytes.alloc(len);
		this.buf.readBytes(b,0,len);
		this.bytesAvailable -= len;
		return b;
	}
	,__class__: protohx.ReadingBuffer
}
protohx.WireType = function() { }
protohx.WireType.__name__ = true;
protohx.WriteUtils = function() { }
protohx.WriteUtils.__name__ = true;
protohx.WriteUtils.writeSingleUnknown = function(output,tag,value) {
	protohx.WriteUtils.write__TYPE_UINT32(output,tag);
	var _g = tag & 7;
	switch(_g) {
	case 0:
		protohx.WriteUtils.write__TYPE_UINT64(output,value);
		break;
	case 1:
		protohx.WriteUtils.write__TYPE_FIXED64(output,value);
		break;
	case 2:
		protohx.WriteUtils.write__TYPE_BYTES(output,value);
		break;
	case 5:
		protohx.WriteUtils.write__TYPE_FIXED32(output,value);
		break;
	default:
		throw new protohx.CommonError("Invalid wire type: " + (tag & 7));
	}
}
protohx.WriteUtils.writeUnknownPair = function(output,tag,value) {
	var repeated = js.Boot.__instanceof(value,Array)?js.Boot.__cast(value , Array):null;
	if(repeated != null) {
		var _g = 0;
		while(_g < repeated.length) {
			var element = repeated[_g];
			++_g;
			protohx.WriteUtils.writeSingleUnknown(output,tag,element);
		}
	} else protohx.WriteUtils.writeSingleUnknown(output,tag,value);
}
protohx.WriteUtils.writeVarint64 = function(output,low,high) {
	if(high == 0) protohx.WriteUtils.write__TYPE_UINT32(output,low); else {
		var _g = 0;
		while(_g < 4) {
			var i = _g++;
			output.writeByte(low & 127 | 128);
			low >>>= 7;
		}
		if((high & -8) == 0) output.writeByte(high << 4 | low); else {
			output.writeByte((high << 4 | low) & 127 | 128);
			protohx.WriteUtils.write__TYPE_UINT32(output,high >>> 3);
		}
	}
}
protohx.WriteUtils.writeTag = function(output,wireType,number) {
	protohx.WriteUtils.write__TYPE_UINT32(output,number << 3 | wireType);
}
protohx.WriteUtils.write__TYPE_DOUBLE = function(output,value) {
	output.writeDouble(value);
}
protohx.WriteUtils.write__TYPE_FLOAT = function(output,value) {
	output.writeFloat(value);
}
protohx.WriteUtils.write__TYPE_INT64 = function(output,value) {
	protohx.WriteUtils.writeVarint64(output,js.Boot.__cast(haxe.Int64.getLow(value) , Int),js.Boot.__cast(haxe.Int64.getHigh(value) , Int));
}
protohx.WriteUtils.write__TYPE_UINT64 = function(output,value) {
	protohx.WriteUtils.writeVarint64(output,js.Boot.__cast(haxe.Int64.getLow(value) , Int),js.Boot.__cast(haxe.Int64.getHigh(value) , Int));
}
protohx.WriteUtils.write__TYPE_INT32 = function(output,value) {
	if(value < 0) protohx.WriteUtils.writeVarint64(output,value,-1); else protohx.WriteUtils.write__TYPE_UINT32(output,value);
}
protohx.WriteUtils.write__TYPE_FIXED64 = function(output,value) {
	output.writeInt32(js.Boot.__cast(haxe.Int64.getLow(value) , Int));
	output.writeInt32(js.Boot.__cast(haxe.Int64.getHigh(value) , Int));
}
protohx.WriteUtils.write__TYPE_FIXED32 = function(output,value) {
	output.writeInt32(value);
}
protohx.WriteUtils.write__TYPE_BOOL = function(output,value) {
	output.writeByte(value?1:0);
}
protohx.WriteUtils.write__TYPE_STRING = function(output,value) {
	var i = output.beginBlock();
	if(value != null) output.writeUTFBytes(value);
	output.endBlock(i);
}
protohx.WriteUtils.write__TYPE_BYTES = function(output,value) {
	if(value != null) {
		protohx.WriteUtils.write__TYPE_UINT32(output,value.length);
		output.writeBytes(value);
	} else protohx.WriteUtils.write__TYPE_UINT32(output,0);
}
protohx.WriteUtils.write__TYPE_UINT32 = function(output,value) {
	while(true) if((value & -128) == 0) {
		output.writeByte(value);
		return;
	} else {
		output.writeByte(value & 127 | 128);
		value >>>= 7;
	}
}
protohx.WriteUtils.write__TYPE_ENUM = function(output,value) {
	protohx.WriteUtils.write__TYPE_INT32(output,value);
}
protohx.WriteUtils.write__TYPE_SFIXED32 = function(output,value) {
	output.writeInt32(value);
}
protohx.WriteUtils.write__TYPE_SFIXED64 = function(output,value) {
	output.writeInt32(js.Boot.__cast(haxe.Int64.getLow(value) , Int));
	output.writeInt32(js.Boot.__cast(haxe.Int64.getHigh(value) , Int));
}
protohx.WriteUtils.write__TYPE_SINT32 = function(output,value) {
	protohx.WriteUtils.write__TYPE_UINT32(output,protohx.ZigZag.encode32(value));
}
protohx.WriteUtils.write__TYPE_SINT64 = function(output,value) {
	protohx.WriteUtils.writeVarint64(output,protohx.ZigZag.encode64low(js.Boot.__cast(haxe.Int64.getLow(value) , Int),js.Boot.__cast(haxe.Int64.getHigh(value) , Int)),protohx.ZigZag.encode64high(js.Boot.__cast(haxe.Int64.getLow(value) , Int),js.Boot.__cast(haxe.Int64.getHigh(value) , Int)));
}
protohx.WriteUtils.write__TYPE_MESSAGE = function(output,value) {
	var i = output.beginBlock();
	value.writeToBuffer(output);
	output.endBlock(i);
}
protohx.WriteUtils.writePackedRepeated = function(output,writeFunction,value) {
	var i = output.beginBlock();
	var _g1 = 0, _g = value.length;
	while(_g1 < _g) {
		var j = _g1++;
		writeFunction.apply(null,[output,value[j]]);
	}
	output.endBlock(i);
}
protohx.WritingBuffer = function() {
	this.slices = new Array();
	this.buf = new haxe.io.BytesOutput();
	protohx.Protohx.setOutputEndian(this.buf);
	this.position = 0;
};
protohx.WritingBuffer.__name__ = true;
protohx.WritingBuffer.prototype = {
	toNormal: function(output) {
		var i = 0;
		var begin = 0;
		var bytes = this.buf.getBytes();
		while(i < this.slices.length) {
			var end = this.slices[i];
			++i;
			if(end > begin) output.writeFullBytes(bytes,begin,end - begin); else if(end < begin) throw new protohx.CommonError("");
			begin = this.slices[i];
			++i;
		}
		output.writeFullBytes(bytes,begin,bytes.length - begin);
	}
	,endBlock: function(beginSliceIndex) {
		this.slices.push(this.position);
		var beginPosition = this.slices[beginSliceIndex + 2];
		this.slices[beginSliceIndex] = this.position;
		protohx.WriteUtils.write__TYPE_UINT32(this,this.position - beginPosition);
		this.slices[beginSliceIndex + 1] = this.position;
		this.slices.push(this.position);
	}
	,beginBlock: function() {
		this.slices.push(this.position);
		var beginSliceIndex = this.slices.length;
		this.slices.push(0);
		this.slices.push(0);
		this.slices.push(this.position);
		return beginSliceIndex;
	}
	,writeByte: function(v) {
		this.buf.writeByte(v);
		this.position += 1;
	}
	,writeInt32: function(v) {
		this.buf.writeInt32(v);
		this.position += 4;
	}
	,writeUTFBytes: function(v) {
		var b = haxe.io.Bytes.ofString(v);
		this.buf.write(b);
		this.position += b.length;
	}
	,writeBytes: function(v) {
		this.buf.write(v);
		this.position += v.length;
	}
	,writeFloat: function(v) {
		this.buf.writeFloat(v);
		this.position += 4;
	}
	,writeDouble: function(v) {
		this.buf.writeDouble(v);
		this.position += 8;
	}
	,__class__: protohx.WritingBuffer
}
protohx.ZigZag = function() { }
protohx.ZigZag.__name__ = true;
protohx.ZigZag.encode32 = function(n) {
	return n << 1 ^ n >> 31;
}
protohx.ZigZag.decode32 = function(n) {
	return n >>> 1 ^ -(n & 1);
}
protohx.ZigZag.encode64low = function(low,high) {
	return low << 1 ^ high >> 31;
}
protohx.ZigZag.encode64high = function(low,high) {
	return low >>> 31 ^ high << 1 ^ high >> 31;
}
protohx.ZigZag.decode64low = function(low,high) {
	return high << 31 ^ low >>> 1 ^ -(low & 1);
}
protohx.ZigZag.decode64high = function(low,high) {
	return high >>> 1 ^ -(low & 1);
}
var samples = {}
samples.ClientPlatform = function() { }
samples.ClientPlatform.__name__ = true;
samples.ClientType = function() { }
samples.ClientType.__name__ = true;
samples.LoginReq = function() {
	this.hasField__0 = 0;
	protohx.Message.call(this);
};
samples.LoginReq.__name__ = true;
samples.LoginReq.__super__ = protohx.Message;
samples.LoginReq.prototype = $extend(protohx.Message.prototype,{
	readFromSlice: function(input,bytesAfterSlice) {
		var status__count = 0;
		var clientType__count = 0;
		var clientPlatform__count = 0;
		while(input.bytesAvailable > bytesAfterSlice) {
			var tag = protohx.ReadUtils.read__TYPE_UINT32(input);
			var _g = tag >> 3;
			switch(_g) {
			case 1:
				if(status__count != 0) throw new protohx.CommonError("Bad data format: LoginReq.status cannot be set twice.");
				++status__count;
				this.set_status(protohx.ReadUtils.read__TYPE_STRING(input));
				break;
			case 2:
				if(clientType__count != 0) throw new protohx.CommonError("Bad data format: LoginReq.clientType cannot be set twice.");
				++clientType__count;
				this.set_clientType(protohx.ReadUtils.read__TYPE_ENUM(input));
				break;
			case 3:
				if(clientPlatform__count != 0) throw new protohx.CommonError("Bad data format: LoginReq.clientPlatform cannot be set twice.");
				++clientPlatform__count;
				this.set_clientPlatform(protohx.ReadUtils.read__TYPE_ENUM(input));
				break;
			default:
				protohx.Message.prototype.readUnknown.call(this,input,tag);
			}
		}
	}
	,forEachFields: function(fn) {
		if(this.get_status() != null) fn("status",this.get_status());
		if((this.hasField__0 & 1) != 0) fn("clientType",this.get_clientType());
		if((this.hasField__0 & 2) != 0) fn("clientPlatform",this.get_clientPlatform());
	}
	,writeToBuffer: function(output) {
		if(this.get_status() != null) {
			protohx.WriteUtils.writeTag(output,2,1);
			protohx.WriteUtils.write__TYPE_STRING(output,this.get_status());
		}
		if((this.hasField__0 & 1) != 0) {
			protohx.WriteUtils.writeTag(output,0,2);
			protohx.WriteUtils.write__TYPE_ENUM(output,this.get_clientType());
		}
		if((this.hasField__0 & 2) != 0) {
			protohx.WriteUtils.writeTag(output,0,3);
			protohx.WriteUtils.write__TYPE_ENUM(output,this.get_clientPlatform());
		}
		protohx.Message.prototype.writeExtensionOrUnknownFields.call(this,output);
	}
	,get_clientPlatform: function() {
		if(!((this.hasField__0 & 2) != 0)) return 0;
		return this.clientPlatform;
	}
	,set_clientPlatform: function(value) {
		this.hasField__0 |= 2;
		return this.clientPlatform = value;
	}
	,hasClientPlatform: function() {
		return (this.hasField__0 & 2) != 0;
	}
	,clearClientPlatform: function() {
		this.hasField__0 &= -3;
		this.set_clientPlatform(0);
	}
	,setClientPlatform: function(value) {
		this.set_clientPlatform(value);
		return this;
	}
	,get_clientType: function() {
		if(!((this.hasField__0 & 1) != 0)) return 0;
		return this.clientType;
	}
	,set_clientType: function(value) {
		this.hasField__0 |= 1;
		return this.clientType = value;
	}
	,hasClientType: function() {
		return (this.hasField__0 & 1) != 0;
	}
	,clearClientType: function() {
		this.hasField__0 &= -2;
		this.set_clientType(0);
	}
	,setClientType: function(value) {
		this.set_clientType(value);
		return this;
	}
	,get_status: function() {
		return this.status;
	}
	,set_status: function(value) {
		return this.status = value;
	}
	,hasStatus: function() {
		return this.get_status() != null;
	}
	,clearStatus: function() {
		this.set_status(null);
	}
	,setStatus: function(value) {
		this.set_status(value);
		return this;
	}
	,__class__: samples.LoginReq
});
samples.LoginRes = function() {
	protohx.Message.call(this);
	this.set_id(0);
};
samples.LoginRes.__name__ = true;
samples.LoginRes.__super__ = protohx.Message;
samples.LoginRes.prototype = $extend(protohx.Message.prototype,{
	readFromSlice: function(input,bytesAfterSlice) {
		var id__count = 0;
		while(input.bytesAvailable > bytesAfterSlice) {
			var tag = protohx.ReadUtils.read__TYPE_UINT32(input);
			var _g = tag >> 3;
			switch(_g) {
			case 1:
				if(id__count != 0) throw new protohx.CommonError("Bad data format: LoginRes.id cannot be set twice.");
				++id__count;
				this.set_id(protohx.ReadUtils.read__TYPE_INT32(input));
				break;
			default:
				protohx.Message.prototype.readUnknown.call(this,input,tag);
			}
		}
	}
	,forEachFields: function(fn) {
		fn("id",this.get_id());
	}
	,writeToBuffer: function(output) {
		protohx.WriteUtils.writeTag(output,0,1);
		protohx.WriteUtils.write__TYPE_INT32(output,this.get_id());
		protohx.Message.prototype.writeExtensionOrUnknownFields.call(this,output);
	}
	,get_id: function() {
		return this.id;
	}
	,set_id: function(value) {
		return this.id = value;
	}
	,setId: function(value) {
		this.set_id(value);
		return this;
	}
	,__class__: samples.LoginRes
});
samples.PlayerData = function() {
	this.hasField__0 = 0;
	protohx.Message.call(this);
};
samples.PlayerData.__name__ = true;
samples.PlayerData.__super__ = protohx.Message;
samples.PlayerData.prototype = $extend(protohx.Message.prototype,{
	readFromSlice: function(input,bytesAfterSlice) {
		var id__count = 0;
		var nick__count = 0;
		var x__count = 0;
		var y__count = 0;
		var status__count = 0;
		var clientType__count = 0;
		var clientPlatform__count = 0;
		while(input.bytesAvailable > bytesAfterSlice) {
			var tag = protohx.ReadUtils.read__TYPE_UINT32(input);
			var _g = tag >> 3;
			switch(_g) {
			case 1:
				if(id__count != 0) throw new protohx.CommonError("Bad data format: PlayerData.id cannot be set twice.");
				++id__count;
				this.set_id(protohx.ReadUtils.read__TYPE_INT32(input));
				break;
			case 2:
				if(nick__count != 0) throw new protohx.CommonError("Bad data format: PlayerData.nick cannot be set twice.");
				++nick__count;
				this.set_nick(protohx.ReadUtils.read__TYPE_STRING(input));
				break;
			case 3:
				if(x__count != 0) throw new protohx.CommonError("Bad data format: PlayerData.x cannot be set twice.");
				++x__count;
				this.set_x(protohx.ReadUtils.read__TYPE_INT32(input));
				break;
			case 4:
				if(y__count != 0) throw new protohx.CommonError("Bad data format: PlayerData.y cannot be set twice.");
				++y__count;
				this.set_y(protohx.ReadUtils.read__TYPE_INT32(input));
				break;
			case 5:
				if(status__count != 0) throw new protohx.CommonError("Bad data format: PlayerData.status cannot be set twice.");
				++status__count;
				this.set_status(protohx.ReadUtils.read__TYPE_STRING(input));
				break;
			case 6:
				if(clientType__count != 0) throw new protohx.CommonError("Bad data format: PlayerData.clientType cannot be set twice.");
				++clientType__count;
				this.set_clientType(protohx.ReadUtils.read__TYPE_ENUM(input));
				break;
			case 7:
				if(clientPlatform__count != 0) throw new protohx.CommonError("Bad data format: PlayerData.clientPlatform cannot be set twice.");
				++clientPlatform__count;
				this.set_clientPlatform(protohx.ReadUtils.read__TYPE_ENUM(input));
				break;
			default:
				protohx.Message.prototype.readUnknown.call(this,input,tag);
			}
		}
	}
	,forEachFields: function(fn) {
		if((this.hasField__0 & 1) != 0) fn("id",this.get_id());
		if(this.get_nick() != null) fn("nick",this.get_nick());
		if((this.hasField__0 & 2) != 0) fn("x",this.get_x());
		if((this.hasField__0 & 4) != 0) fn("y",this.get_y());
		if(this.get_status() != null) fn("status",this.get_status());
		if((this.hasField__0 & 8) != 0) fn("clientType",this.get_clientType());
		if((this.hasField__0 & 16) != 0) fn("clientPlatform",this.get_clientPlatform());
	}
	,writeToBuffer: function(output) {
		if((this.hasField__0 & 1) != 0) {
			protohx.WriteUtils.writeTag(output,0,1);
			protohx.WriteUtils.write__TYPE_INT32(output,this.get_id());
		}
		if(this.get_nick() != null) {
			protohx.WriteUtils.writeTag(output,2,2);
			protohx.WriteUtils.write__TYPE_STRING(output,this.get_nick());
		}
		if((this.hasField__0 & 2) != 0) {
			protohx.WriteUtils.writeTag(output,0,3);
			protohx.WriteUtils.write__TYPE_INT32(output,this.get_x());
		}
		if((this.hasField__0 & 4) != 0) {
			protohx.WriteUtils.writeTag(output,0,4);
			protohx.WriteUtils.write__TYPE_INT32(output,this.get_y());
		}
		if(this.get_status() != null) {
			protohx.WriteUtils.writeTag(output,2,5);
			protohx.WriteUtils.write__TYPE_STRING(output,this.get_status());
		}
		if((this.hasField__0 & 8) != 0) {
			protohx.WriteUtils.writeTag(output,0,6);
			protohx.WriteUtils.write__TYPE_ENUM(output,this.get_clientType());
		}
		if((this.hasField__0 & 16) != 0) {
			protohx.WriteUtils.writeTag(output,0,7);
			protohx.WriteUtils.write__TYPE_ENUM(output,this.get_clientPlatform());
		}
		protohx.Message.prototype.writeExtensionOrUnknownFields.call(this,output);
	}
	,get_clientPlatform: function() {
		if(!((this.hasField__0 & 16) != 0)) return 0;
		return this.clientPlatform;
	}
	,set_clientPlatform: function(value) {
		this.hasField__0 |= 16;
		return this.clientPlatform = value;
	}
	,hasClientPlatform: function() {
		return (this.hasField__0 & 16) != 0;
	}
	,clearClientPlatform: function() {
		this.hasField__0 &= -17;
		this.set_clientPlatform(0);
	}
	,setClientPlatform: function(value) {
		this.set_clientPlatform(value);
		return this;
	}
	,get_clientType: function() {
		if(!((this.hasField__0 & 8) != 0)) return 0;
		return this.clientType;
	}
	,set_clientType: function(value) {
		this.hasField__0 |= 8;
		return this.clientType = value;
	}
	,hasClientType: function() {
		return (this.hasField__0 & 8) != 0;
	}
	,clearClientType: function() {
		this.hasField__0 &= -9;
		this.set_clientType(0);
	}
	,setClientType: function(value) {
		this.set_clientType(value);
		return this;
	}
	,get_status: function() {
		return this.status;
	}
	,set_status: function(value) {
		return this.status = value;
	}
	,hasStatus: function() {
		return this.get_status() != null;
	}
	,clearStatus: function() {
		this.set_status(null);
	}
	,setStatus: function(value) {
		this.set_status(value);
		return this;
	}
	,get_y: function() {
		return this.y;
	}
	,set_y: function(value) {
		this.hasField__0 |= 4;
		return this.y = value;
	}
	,hasY: function() {
		return (this.hasField__0 & 4) != 0;
	}
	,clearY: function() {
		this.hasField__0 &= -5;
		this.set_y(0);
	}
	,setY: function(value) {
		this.set_y(value);
		return this;
	}
	,get_x: function() {
		return this.x;
	}
	,set_x: function(value) {
		this.hasField__0 |= 2;
		return this.x = value;
	}
	,hasX: function() {
		return (this.hasField__0 & 2) != 0;
	}
	,clearX: function() {
		this.hasField__0 &= -3;
		this.set_x(0);
	}
	,setX: function(value) {
		this.set_x(value);
		return this;
	}
	,get_nick: function() {
		return this.nick;
	}
	,set_nick: function(value) {
		return this.nick = value;
	}
	,hasNick: function() {
		return this.get_nick() != null;
	}
	,clearNick: function() {
		this.set_nick(null);
	}
	,setNick: function(value) {
		this.set_nick(value);
		return this;
	}
	,get_id: function() {
		return this.id;
	}
	,set_id: function(value) {
		this.hasField__0 |= 1;
		return this.id = value;
	}
	,hasId: function() {
		return (this.hasField__0 & 1) != 0;
	}
	,clearId: function() {
		this.hasField__0 &= -2;
		this.set_id(0);
	}
	,setId: function(value) {
		this.set_id(value);
		return this;
	}
	,__class__: samples.PlayerData
});
samples.ProtocolMessage = function() {
	protohx.Message.call(this);
	this.set_type(0);
};
samples.ProtocolMessage.__name__ = true;
samples.ProtocolMessage.__super__ = protohx.Message;
samples.ProtocolMessage.prototype = $extend(protohx.Message.prototype,{
	readFromSlice: function(input,bytesAfterSlice) {
		var type__count = 0;
		var loginReq__count = 0;
		var loginRes__count = 0;
		var addPlayerRes__count = 0;
		var updatePlayerReq__count = 0;
		var updatePlayerRes__count = 0;
		var removePlayerRes__count = 0;
		while(input.bytesAvailable > bytesAfterSlice) {
			var tag = protohx.ReadUtils.read__TYPE_UINT32(input);
			var _g = tag >> 3;
			switch(_g) {
			case 1:
				if(type__count != 0) throw new protohx.CommonError("Bad data format: ProtocolMessage.type cannot be set twice.");
				++type__count;
				this.set_type(protohx.ReadUtils.read__TYPE_ENUM(input));
				break;
			case 2:
				if(loginReq__count != 0) throw new protohx.CommonError("Bad data format: ProtocolMessage.loginReq cannot be set twice.");
				++loginReq__count;
				this.set_loginReq(new samples.LoginReq());
				protohx.ReadUtils.read__TYPE_MESSAGE(input,this.get_loginReq());
				break;
			case 3:
				if(loginRes__count != 0) throw new protohx.CommonError("Bad data format: ProtocolMessage.loginRes cannot be set twice.");
				++loginRes__count;
				this.set_loginRes(new samples.LoginRes());
				protohx.ReadUtils.read__TYPE_MESSAGE(input,this.get_loginRes());
				break;
			case 4:
				if(addPlayerRes__count != 0) throw new protohx.CommonError("Bad data format: ProtocolMessage.addPlayerRes cannot be set twice.");
				++addPlayerRes__count;
				this.set_addPlayerRes(new samples.PlayerData());
				protohx.ReadUtils.read__TYPE_MESSAGE(input,this.get_addPlayerRes());
				break;
			case 5:
				if(updatePlayerReq__count != 0) throw new protohx.CommonError("Bad data format: ProtocolMessage.updatePlayerReq cannot be set twice.");
				++updatePlayerReq__count;
				this.set_updatePlayerReq(new samples.PlayerData());
				protohx.ReadUtils.read__TYPE_MESSAGE(input,this.get_updatePlayerReq());
				break;
			case 6:
				if(updatePlayerRes__count != 0) throw new protohx.CommonError("Bad data format: ProtocolMessage.updatePlayerRes cannot be set twice.");
				++updatePlayerRes__count;
				this.set_updatePlayerRes(new samples.PlayerData());
				protohx.ReadUtils.read__TYPE_MESSAGE(input,this.get_updatePlayerRes());
				break;
			case 7:
				if(removePlayerRes__count != 0) throw new protohx.CommonError("Bad data format: ProtocolMessage.removePlayerRes cannot be set twice.");
				++removePlayerRes__count;
				this.set_removePlayerRes(new samples.RemovePlayerRes());
				protohx.ReadUtils.read__TYPE_MESSAGE(input,this.get_removePlayerRes());
				break;
			default:
				protohx.Message.prototype.readUnknown.call(this,input,tag);
			}
		}
	}
	,forEachFields: function(fn) {
		fn("type",this.get_type());
		if(this.get_loginReq() != null) fn("loginReq",this.get_loginReq());
		if(this.get_loginRes() != null) fn("loginRes",this.get_loginRes());
		if(this.get_addPlayerRes() != null) fn("addPlayerRes",this.get_addPlayerRes());
		if(this.get_updatePlayerReq() != null) fn("updatePlayerReq",this.get_updatePlayerReq());
		if(this.get_updatePlayerRes() != null) fn("updatePlayerRes",this.get_updatePlayerRes());
		if(this.get_removePlayerRes() != null) fn("removePlayerRes",this.get_removePlayerRes());
	}
	,writeToBuffer: function(output) {
		protohx.WriteUtils.writeTag(output,0,1);
		protohx.WriteUtils.write__TYPE_ENUM(output,this.get_type());
		if(this.get_loginReq() != null) {
			protohx.WriteUtils.writeTag(output,2,2);
			protohx.WriteUtils.write__TYPE_MESSAGE(output,this.get_loginReq());
		}
		if(this.get_loginRes() != null) {
			protohx.WriteUtils.writeTag(output,2,3);
			protohx.WriteUtils.write__TYPE_MESSAGE(output,this.get_loginRes());
		}
		if(this.get_addPlayerRes() != null) {
			protohx.WriteUtils.writeTag(output,2,4);
			protohx.WriteUtils.write__TYPE_MESSAGE(output,this.get_addPlayerRes());
		}
		if(this.get_updatePlayerReq() != null) {
			protohx.WriteUtils.writeTag(output,2,5);
			protohx.WriteUtils.write__TYPE_MESSAGE(output,this.get_updatePlayerReq());
		}
		if(this.get_updatePlayerRes() != null) {
			protohx.WriteUtils.writeTag(output,2,6);
			protohx.WriteUtils.write__TYPE_MESSAGE(output,this.get_updatePlayerRes());
		}
		if(this.get_removePlayerRes() != null) {
			protohx.WriteUtils.writeTag(output,2,7);
			protohx.WriteUtils.write__TYPE_MESSAGE(output,this.get_removePlayerRes());
		}
		protohx.Message.prototype.writeExtensionOrUnknownFields.call(this,output);
	}
	,get_removePlayerRes: function() {
		return this.removePlayerRes;
	}
	,set_removePlayerRes: function(value) {
		return this.removePlayerRes = value;
	}
	,hasRemovePlayerRes: function() {
		return this.get_removePlayerRes() != null;
	}
	,clearRemovePlayerRes: function() {
		this.set_removePlayerRes(null);
	}
	,setRemovePlayerRes: function(value) {
		this.set_removePlayerRes(value);
		return this;
	}
	,get_updatePlayerRes: function() {
		return this.updatePlayerRes;
	}
	,set_updatePlayerRes: function(value) {
		return this.updatePlayerRes = value;
	}
	,hasUpdatePlayerRes: function() {
		return this.get_updatePlayerRes() != null;
	}
	,clearUpdatePlayerRes: function() {
		this.set_updatePlayerRes(null);
	}
	,setUpdatePlayerRes: function(value) {
		this.set_updatePlayerRes(value);
		return this;
	}
	,get_updatePlayerReq: function() {
		return this.updatePlayerReq;
	}
	,set_updatePlayerReq: function(value) {
		return this.updatePlayerReq = value;
	}
	,hasUpdatePlayerReq: function() {
		return this.get_updatePlayerReq() != null;
	}
	,clearUpdatePlayerReq: function() {
		this.set_updatePlayerReq(null);
	}
	,setUpdatePlayerReq: function(value) {
		this.set_updatePlayerReq(value);
		return this;
	}
	,get_addPlayerRes: function() {
		return this.addPlayerRes;
	}
	,set_addPlayerRes: function(value) {
		return this.addPlayerRes = value;
	}
	,hasAddPlayerRes: function() {
		return this.get_addPlayerRes() != null;
	}
	,clearAddPlayerRes: function() {
		this.set_addPlayerRes(null);
	}
	,setAddPlayerRes: function(value) {
		this.set_addPlayerRes(value);
		return this;
	}
	,get_loginRes: function() {
		return this.loginRes;
	}
	,set_loginRes: function(value) {
		return this.loginRes = value;
	}
	,hasLoginRes: function() {
		return this.get_loginRes() != null;
	}
	,clearLoginRes: function() {
		this.set_loginRes(null);
	}
	,setLoginRes: function(value) {
		this.set_loginRes(value);
		return this;
	}
	,get_loginReq: function() {
		return this.loginReq;
	}
	,set_loginReq: function(value) {
		return this.loginReq = value;
	}
	,hasLoginReq: function() {
		return this.get_loginReq() != null;
	}
	,clearLoginReq: function() {
		this.set_loginReq(null);
	}
	,setLoginReq: function(value) {
		this.set_loginReq(value);
		return this;
	}
	,get_type: function() {
		return this.type;
	}
	,set_type: function(value) {
		return this.type = value;
	}
	,setType: function(value) {
		this.set_type(value);
		return this;
	}
	,__class__: samples.ProtocolMessage
});
samples.RemovePlayerRes = function() {
	protohx.Message.call(this);
	this.set_id(0);
};
samples.RemovePlayerRes.__name__ = true;
samples.RemovePlayerRes.__super__ = protohx.Message;
samples.RemovePlayerRes.prototype = $extend(protohx.Message.prototype,{
	readFromSlice: function(input,bytesAfterSlice) {
		var id__count = 0;
		while(input.bytesAvailable > bytesAfterSlice) {
			var tag = protohx.ReadUtils.read__TYPE_UINT32(input);
			var _g = tag >> 3;
			switch(_g) {
			case 1:
				if(id__count != 0) throw new protohx.CommonError("Bad data format: RemovePlayerRes.id cannot be set twice.");
				++id__count;
				this.set_id(protohx.ReadUtils.read__TYPE_INT32(input));
				break;
			default:
				protohx.Message.prototype.readUnknown.call(this,input,tag);
			}
		}
	}
	,forEachFields: function(fn) {
		fn("id",this.get_id());
	}
	,writeToBuffer: function(output) {
		protohx.WriteUtils.writeTag(output,0,1);
		protohx.WriteUtils.write__TYPE_INT32(output,this.get_id());
		protohx.Message.prototype.writeExtensionOrUnknownFields.call(this,output);
	}
	,get_id: function() {
		return this.id;
	}
	,set_id: function(value) {
		return this.id = value;
	}
	,setId: function(value) {
		this.set_id(value);
		return this;
	}
	,__class__: samples.RemovePlayerRes
});
samples.protocolmessage = {}
samples.protocolmessage.MsgType = function() { }
samples.protocolmessage.MsgType.__name__ = true;
var server = {}
server.logic = {}
server.logic.BakedMsg = function(msg,data) {
	this.msg = msg;
	this.data = data;
};
server.logic.BakedMsg.__name__ = true;
server.logic.BakedMsg.prototype = {
	__class__: server.logic.BakedMsg
}
server.logic.Session = function() {
	this.incomeMsgQueue = new common.MsgQueue();
};
server.logic.Session.__name__ = true;
server.logic.Session.prototype = {
	writeMsg: function(msg) {
	}
	,writeMsgBaked: function(msg) {
		this.writeMsg(msg.msg);
	}
	,bakeMsg: function(msg) {
		return new server.logic.BakedMsg(msg);
	}
	,close: function() {
	}
	,__class__: server.logic.Session
}
server.logic.NetEvent = { __ename__ : true, __constructs__ : ["NEConnect","NEMsg","NEDisconnect"] }
server.logic.NetEvent.NEConnect = ["NEConnect",0];
server.logic.NetEvent.NEConnect.toString = $estr;
server.logic.NetEvent.NEConnect.__enum__ = server.logic.NetEvent;
server.logic.NetEvent.NEMsg = function(type,msg) { var $x = ["NEMsg",1,type,msg]; $x.__enum__ = server.logic.NetEvent; $x.toString = $estr; return $x; }
server.logic.NetEvent.NEDisconnect = ["NEDisconnect",2];
server.logic.NetEvent.NEDisconnect.toString = $estr;
server.logic.NetEvent.NEDisconnect.__enum__ = server.logic.NetEvent;
server.logic.SessionRegistry = function() {
	this.sessions = new List();
	this.sessionId = 0;
	this.sDate = new Date();
	this.byCT = new haxe.ds.IntMap();
	this.byCP = new haxe.ds.IntMap();
};
server.logic.SessionRegistry.__name__ = true;
server.logic.SessionRegistry.isAuthorized = function(session) {
	return session != null && session.player != null;
}
server.logic.SessionRegistry.prototype = {
	handleMsg: function(session,event) {
		var $e = (event);
		switch( $e[1] ) {
		case 0:
			break;
		case 2:
			if(session.player == null) return;
			var removePlayer = new samples.ProtocolMessage();
			removePlayer.set_type(105);
			removePlayer.set_removePlayerRes(new samples.RemovePlayerRes());
			removePlayer.get_removePlayerRes().set_id(session.player.get_id());
			var removePlayerBaked = session.bakeMsg(removePlayer);
			this.forEachSessions(server.logic.SessionRegistry.isAuthorized,function(sessionOther) {
				sessionOther.writeMsgBaked(removePlayerBaked);
			});
			break;
		case 1:
			var event_eNEMsg_1 = $e[3], event_eNEMsg_0 = $e[2];
			switch(event_eNEMsg_0) {
			case 100:
				if(session.player != null) {
					this.log("double login!");
					session.close();
					return;
				}
				var playerData = new samples.PlayerData();
				playerData.set_id(session.id);
				if(event_eNEMsg_1.get_loginReq().get_clientType() == 2) playerData.set_nick("bot" + session.id); else playerData.set_nick("usr" + session.id);
				playerData.set_x(Math.random() * 320 | 0);
				playerData.set_y(Math.random() * 320 | 0);
				playerData.set_status("hi!");
				playerData.set_clientType(event_eNEMsg_1.get_loginReq().get_clientType());
				playerData.set_clientPlatform(event_eNEMsg_1.get_loginReq().get_clientPlatform());
				session.player = playerData;
				var respMsg = new samples.ProtocolMessage();
				respMsg.set_type(101);
				respMsg.set_loginRes(new samples.LoginRes());
				respMsg.get_loginRes().set_id(session.id);
				session.writeMsg(respMsg);
				var addPlayerMsg = new samples.ProtocolMessage();
				addPlayerMsg.set_type(102);
				addPlayerMsg.set_addPlayerRes(session.player);
				var addPlayerMsgBaked = session.bakeMsg(addPlayerMsg);
				this.forEachSessions(server.logic.SessionRegistry.isAuthorized,function(sessionOther) {
					sessionOther.writeMsgBaked(addPlayerMsgBaked);
					if(sessionOther != session) {
						var addOtherPlayer = new samples.ProtocolMessage();
						addOtherPlayer.set_type(102);
						addOtherPlayer.set_addPlayerRes(sessionOther.player);
						session.writeMsg(addOtherPlayer);
					}
				});
				this.scanPlayer(playerData);
				break;
			case 103:
				var player = session.player;
				if(player == null) return;
				var updateData = event_eNEMsg_1.get_updatePlayerReq();
				updateData.set_id(player.get_id());
				if((updateData.hasField__0 & 2) != 0) {
					updateData.set_x(Math.min(Math.max(0,updateData.get_x()),320) | 0);
					player.set_x(updateData.get_x());
				}
				if((updateData.hasField__0 & 4) != 0) {
					updateData.set_y(Math.min(Math.max(0,updateData.get_y()),320) | 0);
					player.set_y(updateData.get_y());
				}
				if(updateData.get_status() != null) player.set_status(updateData.get_status());
				var respMsg = new samples.ProtocolMessage();
				respMsg.set_type(104);
				respMsg.set_updatePlayerRes(updateData);
				var respMsgBaked = session.bakeMsg(respMsg);
				this.forEachSessions(server.logic.SessionRegistry.isAuthorized,function(sessionOther) {
					sessionOther.writeMsgBaked(respMsgBaked);
				});
				break;
			}
			break;
		}
	}
	,sessionData: function(session,bytes) {
		session.incomeMsgQueue.addBytes(bytes);
		while(!session.incomeMsgQueue.msgs.isEmpty()) {
			var msg = session.incomeMsgQueue.msgs.pop();
			console.log("IN: " + protohx.MessageUtils.toJson(msg));
			this.handleMsg(session,server.logic.NetEvent.NEMsg(msg.get_type(),msg));
		}
	}
	,sessionDisconnect: function(session) {
		this.unRegisterSession(session);
		this.handleMsg(session,server.logic.NetEvent.NEDisconnect);
	}
	,sessionConnect: function(session) {
		this.registerSession(session);
		this.handleMsg(session,server.logic.NetEvent.NEConnect);
	}
	,forEachSessions: function(test,body) {
		var $it0 = this.sessions.iterator();
		while( $it0.hasNext() ) {
			var session = $it0.next();
			if(test(session)) body(session);
		}
	}
	,unRegisterSession: function(session) {
		this.sessions.remove(session);
	}
	,registerSession: function(session) {
		session.id = this.nextSessionId();
		this.sessions.add(session);
	}
	,getStatisticsStr: function() {
		var online = 0;
		this.forEachSessions(server.logic.SessionRegistry.isAuthorized,function(s) {
			online++;
		});
		var byTypes = { };
		var $it0 = this.byCT.keys();
		while( $it0.hasNext() ) {
			var key = $it0.next();
			byTypes[common.Config.getTypeName(key)] = this.byCT.get(key);
		}
		var byPlatforms = { };
		var $it1 = this.byCP.keys();
		while( $it1.hasNext() ) {
			var key = $it1.next();
			byPlatforms[common.Config.getPlatformName(key)] = this.byCP.get(key);
		}
		return haxe.Json.stringify({ sDate : this.sDate, nowDate : new Date(), playersHandled : this.sessionId, playersOnline : online, byClientType : byTypes, byClientPlatform : byPlatforms});
	}
	,scanPlayer: function(playerData) {
		var t = this.byCT.get(playerData.get_clientType());
		this.byCT.set(playerData.get_clientType(),t == null?1:t + 1);
		var p = this.byCP.get(playerData.get_clientPlatform());
		this.byCP.set(playerData.get_clientPlatform(),p == null?1:p + 1);
	}
	,nextSessionId: function() {
		this.sessionId++;
		return this.sessionId;
	}
	,log: function(msg) {
		console.log(msg);
	}
	,__class__: server.logic.SessionRegistry
}
server.nodejs = {}
server.nodejs.BotClient = function() { }
server.nodejs.BotClient.__name__ = true;
server.nodejs.BotClient.main = function() {
	var _g = 0;
	while(_g < 20) {
		var i = _g++;
		server.nodejs.BotClient.tcpClientTest("127.0.0.1",15000);
	}
}
server.nodejs.BotClient.tcpClientTest = function(host,port) {
	var msgQueue = new common.MsgQueue();
	var client = server.nodejs.BotClient.net.connect(port,host);
	var id = 0;
	var player = null;
	var timer = 0;
	client.on("connect",function() {
		server.nodejs.BotClient.console.log("client connected to: " + server.nodejs.NodeUtils.addressPort(client));
		var msg = new samples.ProtocolMessage();
		msg.set_type(100);
		msg.set_loginReq(new samples.LoginReq());
		msg.get_loginReq().set_status("ok");
		msg.get_loginReq().set_clientType(2);
		msg.get_loginReq().set_clientPlatform(5);
		server.nodejs.NodeUtils.writeMsgSafe(client,msg);
	});
	client.on("data",function(buffer) {
		var bytes = server.nodejs.NodeUtils.toBytes(buffer);
		msgQueue.addBytes(bytes);
		while(!msgQueue.msgs.isEmpty()) {
			var msg = msgQueue.msgs.pop();
			if(msg.get_type() == 101) id = msg.get_loginRes().get_id(); else if(msg.get_type() == 102) {
				if(id == msg.get_addPlayerRes().get_id()) {
					player = msg.get_addPlayerRes();
					timer = js.Node.setInterval(function() {
						var msg1 = new samples.ProtocolMessage();
						msg1.set_type(103);
						msg1.set_updatePlayerReq(new samples.PlayerData());
						msg1.get_updatePlayerReq().set_x(player.get_x() + Math.floor(Math.random() * 40 - 20));
						msg1.get_updatePlayerReq().set_y(player.get_y() + Math.floor(Math.random() * 40 - 20));
						server.nodejs.NodeUtils.writeMsgSafe(client,msg1);
					},1000 + (1000 * Math.random() | 0));
				}
			} else if(msg.get_type() == 104) {
				if(id == msg.get_updatePlayerRes().get_id()) {
					if((msg.get_updatePlayerRes().hasField__0 & 2) != 0) player.set_x(msg.get_updatePlayerRes().get_x());
					if((msg.get_updatePlayerRes().hasField__0 & 4) != 0) player.set_y(msg.get_updatePlayerRes().get_y());
				}
			}
		}
	});
	client.on("close",function() {
		if(timer != 0) js.Node.clearInterval(timer);
	});
}
server.nodejs.NodeUtils = function() { }
server.nodejs.NodeUtils.__name__ = true;
server.nodejs.NodeUtils.setSession = function(socket,session) {
	socket.ap = server.nodejs.NodeUtils.addressPort(socket);
	socket.session = session;
}
server.nodejs.NodeUtils.getAP = function(socket) {
	return socket.ap;
}
server.nodejs.NodeUtils.getSession = function(socket) {
	return socket.session;
}
server.nodejs.NodeUtils.serverAddressPort = function(server) {
	var a = server.address();
	var address = a.address;
	var port = a.port;
	return "" + address + ":" + port;
}
server.nodejs.NodeUtils.addressPort = function(socket) {
	return "" + socket.remoteAddress + ":" + socket.remotePort;
}
server.nodejs.NodeUtils.writeSafe = function(socket,frame) {
	try {
		socket.write(frame);
	} catch( e ) {
		console.log(e);
	}
}
server.nodejs.NodeUtils.writeMsgSafe = function(socket,msg) {
	try {
		server.nodejs.NodeUtils.writeMsg(socket,msg);
	} catch( e ) {
		console.log(e);
	}
}
server.nodejs.NodeUtils.writeMsg = function(socket,msg) {
	var bytes = server.nodejs.NodeUtils.msgToBytes(msg);
	var frameSize = new Buffer(2);
	frameSize.writeUInt16LE(bytes.length,0);
	var frameData = server.nodejs.NodeUtils.toNodeBuffer(bytes);
	socket.write(frameSize);
	socket.write(frameData);
}
server.nodejs.NodeUtils.toFrame = function(msg) {
	var b = new haxe.io.BytesOutput();
	b.writeUInt16(0);
	msg.writeTo(b);
	var bytes = b.getBytes();
	var frameData = server.nodejs.NodeUtils.toNodeBuffer(bytes);
	frameData.writeUInt16LE(bytes.length - 2,0);
	return frameData;
}
server.nodejs.NodeUtils.toNodeBuffer = function(bytes) {
	return new Buffer(bytes.b);
}
server.nodejs.NodeUtils.msgToBytes = function(msg) {
	var b = new haxe.io.BytesOutput();
	msg.writeTo(b);
	return b.getBytes();
}
server.nodejs.NodeUtils.msgToFrameBytes = function(msg) {
	var b = new haxe.io.BytesOutput();
	msg.writeTo(b);
	var data = b.getBytes();
	var res = new haxe.io.BytesOutput();
	res.writeUInt16(data.length);
	res.write(data);
	return res.getBytes();
}
server.nodejs.NodeUtils.writeBytes = function(socket,bytes) {
	socket.write(server.nodejs.NodeUtils.toNodeBuffer(bytes));
}
server.nodejs.NodeUtils.toBytes = function(buffer) {
	return haxe.io.Bytes.ofData(buffer);
}
Math.__name__ = ["Math"];
Math.NaN = Number.NaN;
Math.NEGATIVE_INFINITY = Number.NEGATIVE_INFINITY;
Math.POSITIVE_INFINITY = Number.POSITIVE_INFINITY;
Math.isFinite = function(i) {
	return isFinite(i);
};
Math.isNaN = function(i) {
	return isNaN(i);
};
String.prototype.__class__ = String;
String.__name__ = true;
Array.prototype.__class__ = Array;
Array.__name__ = true;
Date.prototype.__class__ = Date;
Date.__name__ = ["Date"];
var Int = { __name__ : ["Int"]};
var Dynamic = { __name__ : ["Dynamic"]};
var Float = Number;
Float.__name__ = ["Float"];
var Bool = Boolean;
Bool.__ename__ = ["Bool"];
var Class = { __name__ : ["Class"]};
var Enum = { };
if(typeof(JSON) != "undefined") haxe.Json = JSON;
js.Node.__filename = __filename;
js.Node.__dirname = __dirname;
js.Node.setTimeout = setTimeout;
js.Node.clearTimeout = clearTimeout;
js.Node.setInterval = setInterval;
js.Node.clearInterval = clearInterval;
js.Node.global = global;
js.Node.process = process;
js.Node.require = require;
js.Node.console = console;
js.Node.module = module;
js.Node.stringify = JSON.stringify;
js.Node.parse = JSON.parse;
js.Node.util = js.Node.require("util");
js.Node.fs = js.Node.require("fs");
js.Node.net = js.Node.require("net");
js.Node.http = js.Node.require("http");
js.Node.https = js.Node.require("https");
js.Node.path = js.Node.require("path");
js.Node.url = js.Node.require("url");
js.Node.os = js.Node.require("os");
js.Node.crypto = js.Node.require("crypto");
js.Node.dns = js.Node.require("dns");
js.Node.queryString = js.Node.require("querystring");
js.Node.assert = js.Node.require("assert");
js.Node.childProcess = js.Node.require("child_process");
js.Node.vm = js.Node.require("vm");
js.Node.tls = js.Node.require("tls");
js.Node.dgram = js.Node.require("dgram");
js.Node.assert = js.Node.require("assert");
js.Node.repl = js.Node.require("repl");
js.Node.cluster = js.Node.require("cluster");
common.Config.DEFAULT_HOST = "127.0.0.1";
common.Config.DEFAULT_TCP_PORT = 15000;
common.Config.DEFAULT_HTTP_PORT = 15001;
common.Config.ADDITIONAL_POLICY_PORT = 15002;
common.MsgQueue.HEADER_SIZE = 2;
haxe.io.Output.LN2 = Math.log(2);
js.NodeC.UTF8 = "utf8";
js.NodeC.ASCII = "ascii";
js.NodeC.BINARY = "binary";
js.NodeC.BASE64 = "base64";
js.NodeC.HEX = "hex";
js.NodeC.EVENT_EVENTEMITTER_NEWLISTENER = "newListener";
js.NodeC.EVENT_EVENTEMITTER_ERROR = "error";
js.NodeC.EVENT_STREAM_DATA = "data";
js.NodeC.EVENT_STREAM_END = "end";
js.NodeC.EVENT_STREAM_ERROR = "error";
js.NodeC.EVENT_STREAM_CLOSE = "close";
js.NodeC.EVENT_STREAM_DRAIN = "drain";
js.NodeC.EVENT_STREAM_CONNECT = "connect";
js.NodeC.EVENT_STREAM_SECURE = "secure";
js.NodeC.EVENT_STREAM_TIMEOUT = "timeout";
js.NodeC.EVENT_STREAM_PIPE = "pipe";
js.NodeC.EVENT_PROCESS_EXIT = "exit";
js.NodeC.EVENT_PROCESS_UNCAUGHTEXCEPTION = "uncaughtException";
js.NodeC.EVENT_PROCESS_SIGINT = "SIGINT";
js.NodeC.EVENT_PROCESS_SIGUSR1 = "SIGUSR1";
js.NodeC.EVENT_CHILDPROCESS_EXIT = "exit";
js.NodeC.EVENT_HTTPSERVER_REQUEST = "request";
js.NodeC.EVENT_HTTPSERVER_CONNECTION = "connection";
js.NodeC.EVENT_HTTPSERVER_CLOSE = "close";
js.NodeC.EVENT_HTTPSERVER_UPGRADE = "upgrade";
js.NodeC.EVENT_HTTPSERVER_CLIENTERROR = "clientError";
js.NodeC.EVENT_HTTPSERVERREQUEST_DATA = "data";
js.NodeC.EVENT_HTTPSERVERREQUEST_END = "end";
js.NodeC.EVENT_CLIENTREQUEST_RESPONSE = "response";
js.NodeC.EVENT_CLIENTRESPONSE_DATA = "data";
js.NodeC.EVENT_CLIENTRESPONSE_END = "end";
js.NodeC.EVENT_NETSERVER_CONNECTION = "connection";
js.NodeC.EVENT_NETSERVER_CLOSE = "close";
js.NodeC.FILE_READ = "r";
js.NodeC.FILE_READ_APPEND = "r+";
js.NodeC.FILE_WRITE = "w";
js.NodeC.FILE_WRITE_APPEND = "a+";
js.NodeC.FILE_READWRITE = "a";
js.NodeC.FILE_READWRITE_APPEND = "a+";
protohx.WireType.VARINT = 0;
protohx.WireType.FIXED_64_BIT = 1;
protohx.WireType.LENGTH_DELIMITED = 2;
protohx.WireType.FIXED_32_BIT = 5;
samples.ClientPlatform.CP_UNKNOWN = 0;
samples.ClientPlatform.CP_LINUX = 1;
samples.ClientPlatform.CP_FLASH = 2;
samples.ClientPlatform.CP_ANDROID = 3;
samples.ClientPlatform.CP_HTML5 = 4;
samples.ClientPlatform.CP_NODEJS = 5;
samples.ClientPlatform.CP_WINDOWS = 6;
samples.ClientPlatform.CP_IOS = 7;
samples.ClientType.CT_UNKNOWN = 0;
samples.ClientType.CT_HUMAN = 1;
samples.ClientType.CT_BOT = 2;
samples.protocolmessage.MsgType.LOGIN_REQ = 100;
samples.protocolmessage.MsgType.LOGIN_RES = 101;
samples.protocolmessage.MsgType.ADD_PLAYER_RES = 102;
samples.protocolmessage.MsgType.UPDATE_PLAYER_REQ = 103;
samples.protocolmessage.MsgType.UPDATE_PLAYER_RES = 104;
samples.protocolmessage.MsgType.REMOVE_PLAYER_RES = 105;
server.logic.SessionRegistry.MAX_X = 320;
server.logic.SessionRegistry.MAX_Y = 320;
server.nodejs.BotClient.net = js.Node.net;
server.nodejs.BotClient.console = js.Node.console;
server.nodejs.BotClient.main();
})();
